// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package cardano

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// CardanoClient is the client API for Cardano service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type CardanoClient interface {
	SaveStatistic(ctx context.Context, in *SaveStatisticRequest, opts ...grpc.CallOption) (*SaveStatisticResponse, error)
	GetStatistic(ctx context.Context, in *GetStatisticRequest, opts ...grpc.CallOption) (*GetStatisticResponse, error)
}

type cardanoClient struct {
	cc grpc.ClientConnInterface
}

func NewCardanoClient(cc grpc.ClientConnInterface) CardanoClient {
	return &cardanoClient{cc}
}

func (c *cardanoClient) SaveStatistic(ctx context.Context, in *SaveStatisticRequest, opts ...grpc.CallOption) (*SaveStatisticResponse, error) {
	out := new(SaveStatisticResponse)
	err := c.cc.Invoke(ctx, "/cardano.Cardano/SaveStatistic", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *cardanoClient) GetStatistic(ctx context.Context, in *GetStatisticRequest, opts ...grpc.CallOption) (*GetStatisticResponse, error) {
	out := new(GetStatisticResponse)
	err := c.cc.Invoke(ctx, "/cardano.Cardano/GetStatistic", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// CardanoServer is the server API for Cardano service.
// All implementations must embed UnimplementedCardanoServer
// for forward compatibility
type CardanoServer interface {
	SaveStatistic(context.Context, *SaveStatisticRequest) (*SaveStatisticResponse, error)
	GetStatistic(context.Context, *GetStatisticRequest) (*GetStatisticResponse, error)
	mustEmbedUnimplementedCardanoServer()
}

// UnimplementedCardanoServer must be embedded to have forward compatible implementations.
type UnimplementedCardanoServer struct {
}

func (UnimplementedCardanoServer) SaveStatistic(context.Context, *SaveStatisticRequest) (*SaveStatisticResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SaveStatistic not implemented")
}
func (UnimplementedCardanoServer) GetStatistic(context.Context, *GetStatisticRequest) (*GetStatisticResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetStatistic not implemented")
}
func (UnimplementedCardanoServer) mustEmbedUnimplementedCardanoServer() {}

// UnsafeCardanoServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to CardanoServer will
// result in compilation errors.
type UnsafeCardanoServer interface {
	mustEmbedUnimplementedCardanoServer()
}

func RegisterCardanoServer(s grpc.ServiceRegistrar, srv CardanoServer) {
	s.RegisterService(&Cardano_ServiceDesc, srv)
}

func _Cardano_SaveStatistic_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SaveStatisticRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CardanoServer).SaveStatistic(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/cardano.Cardano/SaveStatistic",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CardanoServer).SaveStatistic(ctx, req.(*SaveStatisticRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Cardano_GetStatistic_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetStatisticRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CardanoServer).GetStatistic(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/cardano.Cardano/GetStatistic",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CardanoServer).GetStatistic(ctx, req.(*GetStatisticRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Cardano_ServiceDesc is the grpc.ServiceDesc for Cardano service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Cardano_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "cardano.Cardano",
	HandlerType: (*CardanoServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "SaveStatistic",
			Handler:    _Cardano_SaveStatistic_Handler,
		},
		{
			MethodName: "GetStatistic",
			Handler:    _Cardano_GetStatistic_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "cardano/cardano.proto",
}
